#include "config.h"
#include <plib/socket.h>
#include "nl80211.h"

#define BASE_ADDRESS 3909156609L /* 233.0.255.1 */
#define BASE_PORT 7000

#define ETH_ALEN 6

struct tdma_tsf {
    u_int64_t zero_time;
    u_int64_t cur_time;
    u_int8_t mac[ETH_ALEN];
}  __attribute__((__packed__));


extern void term_signal(int);
extern void int_signal(int);

extern BOOL exit_flag;

#ifdef HAVE_NETLINK_MSG_H
#include <netlink/genl/genl.h>
#include <netlink/genl/family.h>
#include <netlink/genl/ctrl.h>  
#include <netlink/msg.h>
#include <netlink/attr.h>
#include <netlink/route/link.h>
#endif

struct nl80211_state {
#if defined(CONFIG_LIBNL20) || defined(CONFIG_LIBNL30)
	struct nl_sock *nl_sock;
#else
	struct nl_handle *nl_sock;
#endif
	struct nl_cache *nl_cache;
	struct genl_family *nl80211;
};


struct nl80211_info {
    struct nl80211_state	state;
    int				devidx;
    int				phyidx;
    int				idby;
    int				iftype;
    void			* localcfg;
    int				counter;
};

typedef void (*nl80211_data_prep)(struct nl80211_info *, struct nl_msg*);

extern int nl80211_send_simple_cmd( struct nl80211_info *, int, int, nl80211_data_prep, void *);
extern void iface_prepare_data(struct nl80211_info *, struct nl_msg *);
